Bug 168246 - [em] Multiple legacy em(4) not working with qemu
Summary: [em] Multiple legacy em(4) not working with qemu
Status: Closed FIXED
Alias: None
Product: Base System
Classification: Unclassified
Component: kern (show other bugs)
Version: 9.0-RELEASE
Hardware: Any Any
: Normal Affects Only Me
Assignee: freebsd-net mailing list
URL:
Keywords: IntelNetworking
Depends on:
Blocks:
 
Reported: 2012-05-23 03:20 UTC by Arnaud
Modified: 2016-01-07 17:36 UTC (History)
2 users (show)

See Also:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Arnaud 2012-05-23 03:20:01 UTC
It would seem that FreeBSD is unable to deal correctly with qemu's
networking when *more* than one e1000 interface is exported. TX works, but RX seems broken. re(4) in the exact same configuration works fine.

Fix: 

please.
How-To-Repeat: # qemu -nographic -hda /vm/hdd-freebsd-i386 \
   -net nic -net tap,script=/vm/ifup \
   -net nic -net tap,script=/vm/ifup \
   -net nic -net tap,script=/vm/ifup \
   -net nic -net tap,script=/vm/ifup \
   -net nic -net tap,script=/vm/ifup \
   -net nic -net tap,script=/vm/ifup
Copyright (c) 1992-2012 The FreeBSD Project.
Copyright (c) 1979, 1980, 1983, 1986, 1988, 1989, 1991, 1992, 1993, 1994
       The Regents of the University of California. All rights reserved.
FreeBSD is a registered trademark of The FreeBSD Foundation.
FreeBSD 9.0-RELEASE #0: Tue Jan  3 07:15:25 UTC 2012
   root@obrian.cse.buffalo.edu:/usr/obj/usr/src/sys/GENERIC i386
CPU: QEMU Virtual CPU version 0.14.50 (2660.53-MHz 686-class CPU)
 Origin = "GenuineIntel"  Id = 0x633  Family = 6  Model = 3  Stepping = 3
 Features=0x781abf9<FPU,PSE,TSC,MSR,PAE,MCE,CX8,APIC,SEP,PGE,CMOV,PAT,MMX,FXSR,SSE,SSE2>
 Features2=0x80800001<SSE3,POPCNT,HV>
real memory  = 134205440 (127 MB)
avail memory = 112107520 (106 MB)
[...]
em0: <Intel(R) PRO/1000 Legacy Network Connection 1.0.3> port
0xc040-0xc07f mem 0xf2020000-0xf203ffff irq 11 at device 3.0 on pci0
em0: Memory Access and/or Bus Master bits were not set!
em0: Ethernet address: 52:54:00:12:34:56
[...]
em5: <Intel(R) PRO/1000 Legacy Network Connection 1.0.3> port
0xc180-0xc1bf mem 0xf2160000-0xf217ffff irq 11 at device 8.0 on pci0
em5: Memory Access and/or Bus Master bits were not set!
em5: Ethernet address: 52:54:00:12:34:5b
[...]
# ifconfig em0 10.0.255.2
# ping 10.0.255.1
PING 10.0.255.1 (10.0.255.1): 56 data bytes
ping: sendto: Host is down
ping: sendto: Host is down
ping: sendto: Host is down
Comment 1 Mark Linimon freebsd_committer freebsd_triage 2012-06-08 05:59:39 UTC
Responsible Changed
From-To: freebsd-bugs->freebsd-net

Over to maintainer(s).
Comment 2 Sean Bruno freebsd_committer 2015-07-16 16:30:51 UTC
If you get a chance to retest this, can you try this with 10 or head?  The driver being used in freebsd is lem(4) and not em(4) for this adapter and I'm curious if its still broken for you.
Comment 3 Sean Bruno freebsd_committer 2015-07-23 16:44:43 UTC
If re@ has the time, can a short regression for this be run?
Comment 4 Glen Barber freebsd_committer 2015-07-24 00:32:32 UTC
We do not test with every knob turned and button pushed for testing.

To the OP:  Can you please confirm if this is still an issue with 10.2-BETA2 and later?
Comment 5 Sean Bruno freebsd_committer 2016-01-07 17:36:49 UTC
Tested with the latest FreeBSD11 snapshot and emulators/qemu-devel from ports and this all seems to work just fine now.